purescript-0.15.15: PureScript Programming Language Compiler

Safe Haskell | None
Language | Haskell2010

Language.PureScript.Ide.Types

Description

Type definitions for psc-ide

Synopsis

- type ModuleIdent = Text
- type ModuleMap a = Map ModuleName a
- data IdeDeclaration
  - = IdeDeclValue IdeValue
  - | IdeDeclType IdeType
  - | IdeDeclTypeSynonym IdeTypeSynonym
  - | IdeDeclDataConstructor IdeDataConstructor
  - | IdeDeclTypeClass IdeTypeClass
  - | IdeDeclValueOperator IdeValueOperator
  - | IdeDeclTypeOperator IdeTypeOperator
  - | IdeDeclModule ModuleName
- data IdeValue = IdeValue {
  - _ideValueIdent :: Ident
  - _ideValueType :: SourceType
  }
- data IdeType = IdeType {
  - _ideTypeName :: ProperName 'TypeName
  - _ideTypeKind :: SourceType
  - _ideTypeDtors :: [(ProperName 'ConstructorName, SourceType)]
  }
- data IdeTypeSynonym = IdeTypeSynonym {
  - _ideSynonymName :: ProperName 'TypeName
  - _ideSynonymType :: SourceType
  - _ideSynonymKind :: SourceType
  }
- data IdeDataConstructor = IdeDataConstructor {
  - _ideDtorName :: ProperName 'ConstructorName
  - _ideDtorTypeName :: ProperName 'TypeName
  - _ideDtorType :: SourceType
  }
- data IdeTypeClass = IdeTypeClass {
  - _ideTCName :: ProperName 'ClassName
  - _ideTCKind :: SourceType
  - _ideTCInstances :: [IdeInstance]
  }
- data IdeInstance = IdeInstance {
  - _ideInstanceModule :: ModuleName
  - _ideInstanceName :: Ident
  - _ideInstanceTypes :: [SourceType]
  - _ideInstanceConstraints :: Maybe [SourceConstraint]
  }
- data IdeValueOperator = IdeValueOperator {
  - _ideValueOpName :: OpName 'ValueOpName
  - _ideValueOpAlias :: Qualified (Either Ident (ProperName 'ConstructorName))
  - _ideValueOpPrecedence :: Precedence
  - _ideValueOpAssociativity :: Associativity
  - _ideValueOpType :: Maybe SourceType
  }
- data IdeTypeOperator = IdeTypeOperator {
  - _ideTypeOpName :: OpName 'TypeOpName
  - _ideTypeOpAlias :: Qualified (ProperName 'TypeName)
  - _ideTypeOpPrecedence :: Precedence
  - _ideTypeOpAssociativity :: Associativity
  - _ideTypeOpKind :: Maybe SourceType
  }
- _IdeDeclValue :: Traversal' IdeDeclaration IdeValue
- _IdeDeclType :: Traversal' IdeDeclaration IdeType
- _IdeDeclTypeSynonym :: Traversal' IdeDeclaration IdeTypeSynonym
- _IdeDeclDataConstructor :: Traversal' IdeDeclaration IdeDataConstructor
- _IdeDeclTypeClass :: Traversal' IdeDeclaration IdeTypeClass
- _IdeDeclValueOperator :: Traversal' IdeDeclaration IdeValueOperator
- _IdeDeclTypeOperator :: Traversal' IdeDeclaration IdeTypeOperator
- _IdeDeclModule :: Traversal' IdeDeclaration ModuleName
- anyOf :: Getting Any s a -> (a -> Bool) -> s -> Bool
- ideValueIdent :: Lens' IdeValue Ident
- ideValueType :: Lens' IdeValue SourceType
- ideTypeDtors :: Lens' IdeType [(ProperName 'ConstructorName, SourceType)]
- ideTypeKind :: Lens' IdeType SourceType
- ideTypeName :: Lens' IdeType (ProperName 'TypeName)
- ideSynonymKind :: Lens' IdeTypeSynonym SourceType
- ideSynonymName :: Lens' IdeTypeSynonym (ProperName 'TypeName)
- ideSynonymType :: Lens' IdeTypeSynonym SourceType
- ideDtorName :: Lens' IdeDataConstructor (ProperName 'ConstructorName)
- ideDtorType :: Lens' IdeDataConstructor SourceType
- ideDtorTypeName :: Lens' IdeDataConstructor (ProperName 'TypeName)
- ideTCInstances :: Lens' IdeTypeClass [IdeInstance]
- ideTCKind :: Lens' IdeTypeClass SourceType
- ideTCName :: Lens' IdeTypeClass (ProperName 'ClassName)
- ideValueOpAlias :: Lens' IdeValueOperator (Qualified (Either Ident (ProperName 'ConstructorName)))
- ideValueOpAssociativity :: Lens' IdeValueOperator Associativity
- ideValueOpName :: Lens' IdeValueOperator (OpName 'ValueOpName)
- ideValueOpPrecedence :: Lens' IdeValueOperator Precedence
- ideValueOpType :: Lens' IdeValueOperator (Maybe SourceType)
- ideTypeOpAlias :: Lens' IdeTypeOperator (Qualified (ProperName 'TypeName))
- ideTypeOpAssociativity :: Lens' IdeTypeOperator Associativity
- ideTypeOpKind :: Lens' IdeTypeOperator (Maybe SourceType)
- ideTypeOpName :: Lens' IdeTypeOperator (OpName 'TypeOpName)
- ideTypeOpPrecedence :: Lens' IdeTypeOperator Precedence
- data IdeDeclarationAnn = IdeDeclarationAnn {
  - _idaAnnotation :: Annotation
  - _idaDeclaration :: IdeDeclaration
  }
- data Annotation = Annotation {
  - _annLocation :: Maybe SourceSpan
  - _annExportedFrom :: Maybe ModuleName
  - _annTypeAnnotation :: Maybe SourceType
  - _annDocumentation :: Maybe Text
  }
- annDocumentation :: Lens' Annotation (Maybe Text)
- annExportedFrom :: Lens' Annotation (Maybe ModuleName)
- annLocation :: Lens' Annotation (Maybe SourceSpan)
- annTypeAnnotation :: Lens' Annotation (Maybe SourceType)
- idaAnnotation :: Lens' IdeDeclarationAnn Annotation
- idaDeclaration :: Lens' IdeDeclarationAnn IdeDeclaration
- emptyAnn :: Annotation
- type DefinitionSites a = Map IdeNamespaced a
- type TypeAnnotations = Map Ident SourceType
- newtype AstData a = AstData (ModuleMap (DefinitionSites a, TypeAnnotations))
- data IdeLogLevel
  - = LogDebug
  - | LogPerf
  - | LogAll
  - | LogDefault
  - | LogNone
- data IdeConfiguration = IdeConfiguration {
  - confOutputPath :: FilePath
  - confLogLevel :: IdeLogLevel
  - confGlobs :: [FilePath]
  - confGlobsFromFile :: Maybe FilePath
  - confGlobsExclude :: [FilePath]
  }
- data IdeEnvironment = IdeEnvironment {
  - ideStateVar :: TVar IdeState
  - ideConfiguration :: IdeConfiguration
  - ideCacheDbTimestamp :: IORef (Maybe UTCTime)
  }
- type Ide (m :: Type -> Type) = (MonadIO m, MonadReader IdeEnvironment m)
- data IdeState = IdeState {
  - ideFileState :: IdeFileState
  - ideVolatileState :: IdeVolatileState
  }
- emptyIdeState :: IdeState
- emptyFileState :: IdeFileState
- emptyVolatileState :: IdeVolatileState
- data IdeFileState = IdeFileState {
  - fsExterns :: ModuleMap ExternsFile
  - fsModules :: ModuleMap (Module, FilePath)
  }
- data IdeVolatileState = IdeVolatileState {
  - vsAstData :: AstData SourceSpan
  - vsDeclarations :: ModuleMap [IdeDeclarationAnn]
  - vsCachedRebuild :: Maybe (ModuleName, ExternsFile)
  }
- newtype Match a = Match (ModuleName, a)
- data Completion = Completion {
  - complModule :: Text
  - complIdentifier :: Text
  - complType :: Text
  - complExpandedType :: Text
  - complLocation :: Maybe SourceSpan
  - complDocumentation :: Maybe Text
  - complExportedFrom :: [ModuleName]
  - complDeclarationType :: Maybe DeclarationType
  }
- identifierFromDeclarationRef :: DeclarationRef -> Text
- declarationType :: IdeDeclaration -> DeclarationType
- data Success
  - = CompletionResult [Completion]
  - | TextResult Text
  - | UsagesResult [SourceSpan]
  - | MultilineTextResult [Text]
  - | ImportList (ModuleName, [(ModuleName, ImportDeclarationType, Maybe ModuleName)])
  - | ModuleList [ModuleIdent]
  - | RebuildSuccess MultipleErrors
- encodeSuccess :: ToJSON a => a -> Value
- encodeImport :: (ModuleName, ImportDeclarationType, Maybe ModuleName) -> Value
- data IdeNamespace
  - = IdeNSValue
  - | IdeNSType
  - | IdeNSModule
- data IdeNamespaced = IdeNamespaced IdeNamespace Text

# Documentation

type ModuleIdent = Text #

type ModuleMap a = Map ModuleName a #

data IdeDeclaration #

Constructors

IdeDeclValue IdeValue |
IdeDeclType IdeType |
IdeDeclTypeSynonym IdeTypeSynonym |
IdeDeclDataConstructor IdeDataConstructor |
IdeDeclTypeClass IdeTypeClass |
IdeDeclValueOperator IdeValueOperator |
IdeDeclTypeOperator IdeTypeOperator |
IdeDeclModule ModuleName |

#### Instances

Instances details

NFData IdeDeclaration # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeDeclaration -> () #
Generic IdeDeclaration # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeDeclaration |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDeclaration = D1 ('MetaData "IdeDeclaration" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (((C1 ('MetaCons "IdeDeclValue" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeValue)) :+: C1 ('MetaCons "IdeDeclType" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeType))) :+: (C1 ('MetaCons "IdeDeclTypeSynonym" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeSynonym)) :+: C1 ('MetaCons "IdeDeclDataConstructor" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeDataConstructor)))) :+: ((C1 ('MetaCons "IdeDeclTypeClass" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeClass)) :+: C1 ('MetaCons "IdeDeclValueOperator" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeValueOperator))) :+: (C1 ('MetaCons "IdeDeclTypeOperator" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeOperator)) :+: C1 ('MetaCons "IdeDeclModule" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ModuleName)))))

Methods

from :: IdeDeclaration -> Rep IdeDeclaration x #

to :: Rep IdeDeclaration x -> IdeDeclaration #

Show IdeDeclaration # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeDeclaration -> ShowS # show :: IdeDeclaration -> String # showList :: [IdeDeclaration] -> ShowS #
Eq IdeDeclaration # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeDeclaration -> IdeDeclaration -> Bool # (/=) :: IdeDeclaration -> IdeDeclaration -> Bool #
Ord IdeDeclaration # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeDeclaration -> IdeDeclaration -> Ordering #

(<) :: IdeDeclaration -> IdeDeclaration -> Bool #

(<=) :: IdeDeclaration -> IdeDeclaration -> Bool #

(>) :: IdeDeclaration -> IdeDeclaration -> Bool #

(>=) :: IdeDeclaration -> IdeDeclaration -> Bool #

max :: IdeDeclaration -> IdeDeclaration -> IdeDeclaration #

min :: IdeDeclaration -> IdeDeclaration -> IdeDeclaration #

type Rep IdeDeclaration # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDeclaration = D1 ('MetaData "IdeDeclaration" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (((C1 ('MetaCons "IdeDeclValue" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeValue)) :+: C1 ('MetaCons "IdeDeclType" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeType))) :+: (C1 ('MetaCons "IdeDeclTypeSynonym" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeSynonym)) :+: C1 ('MetaCons "IdeDeclDataConstructor" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeDataConstructor)))) :+: ((C1 ('MetaCons "IdeDeclTypeClass" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeClass)) :+: C1 ('MetaCons "IdeDeclValueOperator" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeValueOperator))) :+: (C1 ('MetaCons "IdeDeclTypeOperator" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeTypeOperator)) :+: C1 ('MetaCons "IdeDeclModule" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ModuleName)))))

data IdeValue #

Constructors

IdeValue |

Fields

- _ideValueIdent :: Ident
- _ideValueType :: SourceType

#### Instances

Instances details

NFData IdeValue # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeValue -> () #
Generic IdeValue # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeValue |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeValue = D1 ('MetaData "IdeValue" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeValue" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideValueIdent") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Ident) :*: S1 ('MetaSel ('Just "_ideValueType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType)))

Methods

from :: IdeValue -> Rep IdeValue x #

to :: Rep IdeValue x -> IdeValue #

Show IdeValue # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeValue -> ShowS # show :: IdeValue -> String # showList :: [IdeValue] -> ShowS #
Eq IdeValue # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeValue -> IdeValue -> Bool # (/=) :: IdeValue -> IdeValue -> Bool #
Ord IdeValue # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: IdeValue -> IdeValue -> Ordering # (<) :: IdeValue -> IdeValue -> Bool # (<=) :: IdeValue -> IdeValue -> Bool # (>) :: IdeValue -> IdeValue -> Bool # (>=) :: IdeValue -> IdeValue -> Bool # max :: IdeValue -> IdeValue -> IdeValue # min :: IdeValue -> IdeValue -> IdeValue #
type Rep IdeValue # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeValue = D1 ('MetaData "IdeValue" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeValue" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideValueIdent") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Ident) :*: S1 ('MetaSel ('Just "_ideValueType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType)))

data IdeType #

Constructors

IdeType |

Fields

- _ideTypeName :: ProperName 'TypeName
- _ideTypeKind :: SourceType
- _ideTypeDtors :: [(ProperName 'ConstructorName, SourceType)]

#### Instances

Instances details

NFData IdeType # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeType -> () #
Generic IdeType # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeType |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeType = D1 ('MetaData "IdeType" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeType" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideTypeName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: (S1 ('MetaSel ('Just "_ideTypeKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideTypeDtors") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [(ProperName 'ConstructorName, SourceType)]))))

Methods

from :: IdeType -> Rep IdeType x #

to :: Rep IdeType x -> IdeType #

Show IdeType # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeType -> ShowS # show :: IdeType -> String # showList :: [IdeType] -> ShowS #
Eq IdeType # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeType -> IdeType -> Bool # (/=) :: IdeType -> IdeType -> Bool #
Ord IdeType # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: IdeType -> IdeType -> Ordering # (<) :: IdeType -> IdeType -> Bool # (<=) :: IdeType -> IdeType -> Bool # (>) :: IdeType -> IdeType -> Bool # (>=) :: IdeType -> IdeType -> Bool # max :: IdeType -> IdeType -> IdeType # min :: IdeType -> IdeType -> IdeType #
type Rep IdeType # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeType = D1 ('MetaData "IdeType" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeType" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideTypeName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: (S1 ('MetaSel ('Just "_ideTypeKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideTypeDtors") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [(ProperName 'ConstructorName, SourceType)]))))

data IdeTypeSynonym #

Constructors

IdeTypeSynonym |

Fields

- _ideSynonymName :: ProperName 'TypeName
- _ideSynonymType :: SourceType
- _ideSynonymKind :: SourceType

#### Instances

Instances details

NFData IdeTypeSynonym # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeTypeSynonym -> () #
Generic IdeTypeSynonym # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeTypeSynonym |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeSynonym = D1 ('MetaData "IdeTypeSynonym" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeSynonym" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideSynonymName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: (S1 ('MetaSel ('Just "_ideSynonymType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideSynonymKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType))))

Methods

from :: IdeTypeSynonym -> Rep IdeTypeSynonym x #

to :: Rep IdeTypeSynonym x -> IdeTypeSynonym #

Show IdeTypeSynonym # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeTypeSynonym -> ShowS # show :: IdeTypeSynonym -> String # showList :: [IdeTypeSynonym] -> ShowS #
Eq IdeTypeSynonym # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool # (/=) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool #
Ord IdeTypeSynonym # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeTypeSynonym -> IdeTypeSynonym -> Ordering #

(<) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool #

(<=) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool #

(>) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool #

(>=) :: IdeTypeSynonym -> IdeTypeSynonym -> Bool #

max :: IdeTypeSynonym -> IdeTypeSynonym -> IdeTypeSynonym #

min :: IdeTypeSynonym -> IdeTypeSynonym -> IdeTypeSynonym #

type Rep IdeTypeSynonym # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeSynonym = D1 ('MetaData "IdeTypeSynonym" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeSynonym" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideSynonymName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: (S1 ('MetaSel ('Just "_ideSynonymType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideSynonymKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType))))

data IdeDataConstructor #

Constructors

IdeDataConstructor |

Fields

- _ideDtorName :: ProperName 'ConstructorName
- _ideDtorTypeName :: ProperName 'TypeName
- _ideDtorType :: SourceType

#### Instances

Instances details

NFData IdeDataConstructor # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeDataConstructor -> () #
Generic IdeDataConstructor # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeDataConstructor |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDataConstructor = D1 ('MetaData "IdeDataConstructor" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeDataConstructor" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideDtorName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'ConstructorName)) :*: (S1 ('MetaSel ('Just "_ideDtorTypeName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: S1 ('MetaSel ('Just "_ideDtorType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType))))

Methods

from :: IdeDataConstructor -> Rep IdeDataConstructor x #

to :: Rep IdeDataConstructor x -> IdeDataConstructor #

Show IdeDataConstructor # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeDataConstructor -> ShowS # show :: IdeDataConstructor -> String # showList :: [IdeDataConstructor] -> ShowS #
Eq IdeDataConstructor # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeDataConstructor -> IdeDataConstructor -> Bool # (/=) :: IdeDataConstructor -> IdeDataConstructor -> Bool #
Ord IdeDataConstructor # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeDataConstructor -> IdeDataConstructor -> Ordering #

(<) :: IdeDataConstructor -> IdeDataConstructor -> Bool #

(<=) :: IdeDataConstructor -> IdeDataConstructor -> Bool #

(>) :: IdeDataConstructor -> IdeDataConstructor -> Bool #

(>=) :: IdeDataConstructor -> IdeDataConstructor -> Bool #

max :: IdeDataConstructor -> IdeDataConstructor -> IdeDataConstructor #

min :: IdeDataConstructor -> IdeDataConstructor -> IdeDataConstructor #

type Rep IdeDataConstructor # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDataConstructor = D1 ('MetaData "IdeDataConstructor" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeDataConstructor" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideDtorName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'ConstructorName)) :*: (S1 ('MetaSel ('Just "_ideDtorTypeName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'TypeName)) :*: S1 ('MetaSel ('Just "_ideDtorType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType))))

data IdeTypeClass #

Constructors

IdeTypeClass |

Fields

- _ideTCName :: ProperName 'ClassName
- _ideTCKind :: SourceType
- _ideTCInstances :: [IdeInstance]

#### Instances

Instances details

NFData IdeTypeClass # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeTypeClass -> () #
Generic IdeTypeClass # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeTypeClass |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeClass = D1 ('MetaData "IdeTypeClass" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeClass" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideTCName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'ClassName)) :*: (S1 ('MetaSel ('Just "_ideTCKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideTCInstances") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [IdeInstance]))))

Methods

from :: IdeTypeClass -> Rep IdeTypeClass x #

to :: Rep IdeTypeClass x -> IdeTypeClass #

Show IdeTypeClass # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeTypeClass -> ShowS # show :: IdeTypeClass -> String # showList :: [IdeTypeClass] -> ShowS #
Eq IdeTypeClass # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeTypeClass -> IdeTypeClass -> Bool # (/=) :: IdeTypeClass -> IdeTypeClass -> Bool #
Ord IdeTypeClass # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeTypeClass -> IdeTypeClass -> Ordering #

(<) :: IdeTypeClass -> IdeTypeClass -> Bool #

(<=) :: IdeTypeClass -> IdeTypeClass -> Bool #

(>) :: IdeTypeClass -> IdeTypeClass -> Bool #

(>=) :: IdeTypeClass -> IdeTypeClass -> Bool #

max :: IdeTypeClass -> IdeTypeClass -> IdeTypeClass #

min :: IdeTypeClass -> IdeTypeClass -> IdeTypeClass #

type Rep IdeTypeClass # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeClass = D1 ('MetaData "IdeTypeClass" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeClass" 'PrefixI 'True) (S1 ('MetaSel ('Just "_ideTCName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ProperName 'ClassName)) :*: (S1 ('MetaSel ('Just "_ideTCKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceType) :*: S1 ('MetaSel ('Just "_ideTCInstances") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [IdeInstance]))))

data IdeInstance #

Constructors

IdeInstance |

Fields

- _ideInstanceModule :: ModuleName
- _ideInstanceName :: Ident
- _ideInstanceTypes :: [SourceType]
- _ideInstanceConstraints :: Maybe [SourceConstraint]

#### Instances

Instances details

NFData IdeInstance # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeInstance -> () #
Generic IdeInstance # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeInstance |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeInstance = D1 ('MetaData "IdeInstance" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeInstance" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideInstanceModule") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ModuleName) :*: S1 ('MetaSel ('Just "_ideInstanceName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Ident)) :*: (S1 ('MetaSel ('Just "_ideInstanceTypes") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [SourceType]) :*: S1 ('MetaSel ('Just "_ideInstanceConstraints") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe [SourceConstraint])))))

Methods

from :: IdeInstance -> Rep IdeInstance x #

to :: Rep IdeInstance x -> IdeInstance #

Show IdeInstance # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeInstance -> ShowS # show :: IdeInstance -> String # showList :: [IdeInstance] -> ShowS #
Eq IdeInstance # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeInstance -> IdeInstance -> Bool # (/=) :: IdeInstance -> IdeInstance -> Bool #
Ord IdeInstance # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: IdeInstance -> IdeInstance -> Ordering # (<) :: IdeInstance -> IdeInstance -> Bool # (<=) :: IdeInstance -> IdeInstance -> Bool # (>) :: IdeInstance -> IdeInstance -> Bool # (>=) :: IdeInstance -> IdeInstance -> Bool # max :: IdeInstance -> IdeInstance -> IdeInstance # min :: IdeInstance -> IdeInstance -> IdeInstance #
type Rep IdeInstance # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeInstance = D1 ('MetaData "IdeInstance" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeInstance" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideInstanceModule") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ModuleName) :*: S1 ('MetaSel ('Just "_ideInstanceName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Ident)) :*: (S1 ('MetaSel ('Just "_ideInstanceTypes") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [SourceType]) :*: S1 ('MetaSel ('Just "_ideInstanceConstraints") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe [SourceConstraint])))))

data IdeValueOperator #

Constructors

IdeValueOperator |

Fields

- _ideValueOpName :: OpName 'ValueOpName
- _ideValueOpAlias :: Qualified (Either Ident (ProperName 'ConstructorName))
- _ideValueOpPrecedence :: Precedence
- _ideValueOpAssociativity :: Associativity
- _ideValueOpType :: Maybe SourceType

#### Instances

Instances details

NFData IdeValueOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeValueOperator -> () #
Generic IdeValueOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeValueOperator |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeValueOperator = D1 ('MetaData "IdeValueOperator" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeValueOperator" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideValueOpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (OpName 'ValueOpName)) :*: S1 ('MetaSel ('Just "_ideValueOpAlias") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Qualified (Either Ident (ProperName 'ConstructorName))))) :*: (S1 ('MetaSel ('Just "_ideValueOpPrecedence") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Precedence) :*: (S1 ('MetaSel ('Just "_ideValueOpAssociativity") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Associativity) :*: S1 ('MetaSel ('Just "_ideValueOpType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType))))))

Methods

from :: IdeValueOperator -> Rep IdeValueOperator x #

to :: Rep IdeValueOperator x -> IdeValueOperator #

Show IdeValueOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeValueOperator -> ShowS # show :: IdeValueOperator -> String # showList :: [IdeValueOperator] -> ShowS #
Eq IdeValueOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeValueOperator -> IdeValueOperator -> Bool # (/=) :: IdeValueOperator -> IdeValueOperator -> Bool #
Ord IdeValueOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeValueOperator -> IdeValueOperator -> Ordering #

(<) :: IdeValueOperator -> IdeValueOperator -> Bool #

(<=) :: IdeValueOperator -> IdeValueOperator -> Bool #

(>) :: IdeValueOperator -> IdeValueOperator -> Bool #

(>=) :: IdeValueOperator -> IdeValueOperator -> Bool #

max :: IdeValueOperator -> IdeValueOperator -> IdeValueOperator #

min :: IdeValueOperator -> IdeValueOperator -> IdeValueOperator #

type Rep IdeValueOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeValueOperator = D1 ('MetaData "IdeValueOperator" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeValueOperator" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideValueOpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (OpName 'ValueOpName)) :*: S1 ('MetaSel ('Just "_ideValueOpAlias") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Qualified (Either Ident (ProperName 'ConstructorName))))) :*: (S1 ('MetaSel ('Just "_ideValueOpPrecedence") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Precedence) :*: (S1 ('MetaSel ('Just "_ideValueOpAssociativity") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Associativity) :*: S1 ('MetaSel ('Just "_ideValueOpType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType))))))

data IdeTypeOperator #

Constructors

IdeTypeOperator |

Fields

- _ideTypeOpName :: OpName 'TypeOpName
- _ideTypeOpAlias :: Qualified (ProperName 'TypeName)
- _ideTypeOpPrecedence :: Precedence
- _ideTypeOpAssociativity :: Associativity
- _ideTypeOpKind :: Maybe SourceType

#### Instances

Instances details

NFData IdeTypeOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeTypeOperator -> () #
Generic IdeTypeOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeTypeOperator |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeOperator = D1 ('MetaData "IdeTypeOperator" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeOperator" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideTypeOpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (OpName 'TypeOpName)) :*: S1 ('MetaSel ('Just "_ideTypeOpAlias") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Qualified (ProperName 'TypeName)))) :*: (S1 ('MetaSel ('Just "_ideTypeOpPrecedence") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Precedence) :*: (S1 ('MetaSel ('Just "_ideTypeOpAssociativity") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Associativity) :*: S1 ('MetaSel ('Just "_ideTypeOpKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType))))))

Methods

from :: IdeTypeOperator -> Rep IdeTypeOperator x #

to :: Rep IdeTypeOperator x -> IdeTypeOperator #

Show IdeTypeOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeTypeOperator -> ShowS # show :: IdeTypeOperator -> String # showList :: [IdeTypeOperator] -> ShowS #
Eq IdeTypeOperator # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeTypeOperator -> IdeTypeOperator -> Bool # (/=) :: IdeTypeOperator -> IdeTypeOperator -> Bool #
Ord IdeTypeOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeTypeOperator -> IdeTypeOperator -> Ordering #

(<) :: IdeTypeOperator -> IdeTypeOperator -> Bool #

(<=) :: IdeTypeOperator -> IdeTypeOperator -> Bool #

(>) :: IdeTypeOperator -> IdeTypeOperator -> Bool #

(>=) :: IdeTypeOperator -> IdeTypeOperator -> Bool #

max :: IdeTypeOperator -> IdeTypeOperator -> IdeTypeOperator #

min :: IdeTypeOperator -> IdeTypeOperator -> IdeTypeOperator #

type Rep IdeTypeOperator # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeTypeOperator = D1 ('MetaData "IdeTypeOperator" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeTypeOperator" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_ideTypeOpName") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (OpName 'TypeOpName)) :*: S1 ('MetaSel ('Just "_ideTypeOpAlias") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Qualified (ProperName 'TypeName)))) :*: (S1 ('MetaSel ('Just "_ideTypeOpPrecedence") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Precedence) :*: (S1 ('MetaSel ('Just "_ideTypeOpAssociativity") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Associativity) :*: S1 ('MetaSel ('Just "_ideTypeOpKind") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType))))))

_IdeDeclValue :: Traversal' IdeDeclaration IdeValue #

_IdeDeclType :: Traversal' IdeDeclaration IdeType #

_IdeDeclTypeSynonym :: Traversal' IdeDeclaration IdeTypeSynonym #

_IdeDeclDataConstructor :: Traversal' IdeDeclaration IdeDataConstructor #

_IdeDeclTypeClass :: Traversal' IdeDeclaration IdeTypeClass #

_IdeDeclValueOperator :: Traversal' IdeDeclaration IdeValueOperator #

_IdeDeclTypeOperator :: Traversal' IdeDeclaration IdeTypeOperator #

_IdeDeclModule :: Traversal' IdeDeclaration ModuleName #

anyOf :: Getting Any s a -> (a -> Bool) -> s -> Bool #

ideValueIdent :: Lens' IdeValue Ident #

ideValueType :: Lens' IdeValue SourceType #

ideTypeDtors :: Lens' IdeType [(ProperName 'ConstructorName, SourceType)] #

ideTypeKind :: Lens' IdeType SourceType #

ideTypeName :: Lens' IdeType (ProperName 'TypeName) #

ideSynonymKind :: Lens' IdeTypeSynonym SourceType #

ideSynonymName :: Lens' IdeTypeSynonym (ProperName 'TypeName) #

ideSynonymType :: Lens' IdeTypeSynonym SourceType #

ideDtorName :: Lens' IdeDataConstructor (ProperName 'ConstructorName) #

ideDtorType :: Lens' IdeDataConstructor SourceType #

ideDtorTypeName :: Lens' IdeDataConstructor (ProperName 'TypeName) #

ideTCInstances :: Lens' IdeTypeClass [IdeInstance] #

ideTCKind :: Lens' IdeTypeClass SourceType #

ideTCName :: Lens' IdeTypeClass (ProperName 'ClassName) #

ideValueOpAlias :: Lens' IdeValueOperator (Qualified (Either Ident (ProperName 'ConstructorName))) #

ideValueOpAssociativity :: Lens' IdeValueOperator Associativity #

ideValueOpName :: Lens' IdeValueOperator (OpName 'ValueOpName) #

ideValueOpPrecedence :: Lens' IdeValueOperator Precedence #

ideValueOpType :: Lens' IdeValueOperator (Maybe SourceType) #

ideTypeOpAlias :: Lens' IdeTypeOperator (Qualified (ProperName 'TypeName)) #

ideTypeOpAssociativity :: Lens' IdeTypeOperator Associativity #

ideTypeOpKind :: Lens' IdeTypeOperator (Maybe SourceType) #

ideTypeOpName :: Lens' IdeTypeOperator (OpName 'TypeOpName) #

ideTypeOpPrecedence :: Lens' IdeTypeOperator Precedence #

data IdeDeclarationAnn #

Constructors

IdeDeclarationAnn |

Fields

- _idaAnnotation :: Annotation
- _idaDeclaration :: IdeDeclaration

#### Instances

Instances details

NFData IdeDeclarationAnn # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeDeclarationAnn -> () #
Generic IdeDeclarationAnn # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeDeclarationAnn |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDeclarationAnn = D1 ('MetaData "IdeDeclarationAnn" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeDeclarationAnn" 'PrefixI 'True) (S1 ('MetaSel ('Just "_idaAnnotation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Annotation) :*: S1 ('MetaSel ('Just "_idaDeclaration") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeDeclaration)))

Methods

from :: IdeDeclarationAnn -> Rep IdeDeclarationAnn x #

to :: Rep IdeDeclarationAnn x -> IdeDeclarationAnn #

Show IdeDeclarationAnn # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeDeclarationAnn -> ShowS # show :: IdeDeclarationAnn -> String # showList :: [IdeDeclarationAnn] -> ShowS #
Eq IdeDeclarationAnn # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool # (/=) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool #
Ord IdeDeclarationAnn # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeDeclarationAnn -> IdeDeclarationAnn -> Ordering #

(<) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool #

(<=) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool #

(>) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool #

(>=) :: IdeDeclarationAnn -> IdeDeclarationAnn -> Bool #

max :: IdeDeclarationAnn -> IdeDeclarationAnn -> IdeDeclarationAnn #

min :: IdeDeclarationAnn -> IdeDeclarationAnn -> IdeDeclarationAnn #

FromJSON (Matcher IdeDeclarationAnn) # |
Instance details Defined in Language.PureScript.Ide.Matcher Methods parseJSON :: Value -> Parser (Matcher IdeDeclarationAnn) # parseJSONList :: Value -> Parser [Matcher IdeDeclarationAnn] # omittedField :: Maybe (Matcher IdeDeclarationAnn) #
type Rep IdeDeclarationAnn # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeDeclarationAnn = D1 ('MetaData "IdeDeclarationAnn" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeDeclarationAnn" 'PrefixI 'True) (S1 ('MetaSel ('Just "_idaAnnotation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Annotation) :*: S1 ('MetaSel ('Just "_idaDeclaration") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeDeclaration)))

data Annotation #

Constructors

Annotation |

Fields

- _annLocation :: Maybe SourceSpan
- _annExportedFrom :: Maybe ModuleName
- _annTypeAnnotation :: Maybe SourceType
- _annDocumentation :: Maybe Text

#### Instances

Instances details

NFData Annotation # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: Annotation -> () #
Generic Annotation # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep Annotation |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep Annotation = D1 ('MetaData "Annotation" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "Annotation" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_annLocation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceSpan)) :*: S1 ('MetaSel ('Just "_annExportedFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe ModuleName))) :*: (S1 ('MetaSel ('Just "_annTypeAnnotation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType)) :*: S1 ('MetaSel ('Just "_annDocumentation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)))))

Methods

from :: Annotation -> Rep Annotation x #

to :: Rep Annotation x -> Annotation #

Show Annotation # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> Annotation -> ShowS # show :: Annotation -> String # showList :: [Annotation] -> ShowS #
Eq Annotation # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: Annotation -> Annotation -> Bool # (/=) :: Annotation -> Annotation -> Bool #
Ord Annotation # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: Annotation -> Annotation -> Ordering # (<) :: Annotation -> Annotation -> Bool # (<=) :: Annotation -> Annotation -> Bool # (>) :: Annotation -> Annotation -> Bool # (>=) :: Annotation -> Annotation -> Bool # max :: Annotation -> Annotation -> Annotation # min :: Annotation -> Annotation -> Annotation #
type Rep Annotation # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep Annotation = D1 ('MetaData "Annotation" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "Annotation" 'PrefixI 'True) ((S1 ('MetaSel ('Just "_annLocation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceSpan)) :*: S1 ('MetaSel ('Just "_annExportedFrom") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe ModuleName))) :*: (S1 ('MetaSel ('Just "_annTypeAnnotation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe SourceType)) :*: S1 ('MetaSel ('Just "_annDocumentation") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)))))

annDocumentation :: Lens' Annotation (Maybe Text) #

annExportedFrom :: Lens' Annotation (Maybe ModuleName) #

annLocation :: Lens' Annotation (Maybe SourceSpan) #

annTypeAnnotation :: Lens' Annotation (Maybe SourceType) #

idaAnnotation :: Lens' IdeDeclarationAnn Annotation #

idaDeclaration :: Lens' IdeDeclarationAnn IdeDeclaration #

emptyAnn :: Annotation #

type DefinitionSites a = Map IdeNamespaced a #

type TypeAnnotations = Map Ident SourceType #

newtype AstData a #

Constructors

AstData (ModuleMap (DefinitionSites a, TypeAnnotations)) | SourceSpans for the definition sites of values and types as well as type annotations found in a module

#### Instances

Instances details

Functor AstData # |
Instance details Defined in Language.PureScript.Ide.Types Methods fmap :: (a -> b) -> AstData a -> AstData b # (<$) :: a -> AstData b -> AstData a #
Foldable AstData # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

fold :: Monoid m => AstData m -> m #

foldMap :: Monoid m => (a -> m) -> AstData a -> m #

foldMap' :: Monoid m => (a -> m) -> AstData a -> m #

foldr :: (a -> b -> b) -> b -> AstData a -> b #

foldr' :: (a -> b -> b) -> b -> AstData a -> b #

foldl :: (b -> a -> b) -> b -> AstData a -> b #

foldl' :: (b -> a -> b) -> b -> AstData a -> b #

foldr1 :: (a -> a -> a) -> AstData a -> a #

foldl1 :: (a -> a -> a) -> AstData a -> a #

toList :: AstData a -> [a] #

null :: AstData a -> Bool #

length :: AstData a -> Int #

elem :: Eq a => a -> AstData a -> Bool #

maximum :: Ord a => AstData a -> a #

minimum :: Ord a => AstData a -> a #

sum :: Num a => AstData a -> a #

product :: Num a => AstData a -> a #

NFData a => NFData (AstData a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: AstData a -> () #
Generic (AstData a) # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep (AstData a) |
Instance details Defined in Language.PureScript.Ide.Types type Rep (AstData a) = D1 ('MetaData "AstData" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'True) (C1 ('MetaCons "AstData" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ModuleMap (DefinitionSites a, TypeAnnotations)))))

Methods

from :: AstData a -> Rep (AstData a) x #

to :: Rep (AstData a) x -> AstData a #

Show a => Show (AstData a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> AstData a -> ShowS # show :: AstData a -> String # showList :: [AstData a] -> ShowS #
Eq a => Eq (AstData a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: AstData a -> AstData a -> Bool # (/=) :: AstData a -> AstData a -> Bool #
Ord a => Ord (AstData a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: AstData a -> AstData a -> Ordering # (<) :: AstData a -> AstData a -> Bool # (<=) :: AstData a -> AstData a -> Bool # (>) :: AstData a -> AstData a -> Bool # (>=) :: AstData a -> AstData a -> Bool # max :: AstData a -> AstData a -> AstData a # min :: AstData a -> AstData a -> AstData a #
type Rep (AstData a) # |
Instance details Defined in Language.PureScript.Ide.Types type Rep (AstData a) = D1 ('MetaData "AstData" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'True) (C1 ('MetaCons "AstData" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (ModuleMap (DefinitionSites a, TypeAnnotations)))))

data IdeLogLevel #

Constructors

LogDebug |
LogPerf |
LogAll |
LogDefault |
LogNone |

#### Instances

Instances details

Show IdeLogLevel # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeLogLevel -> ShowS # show :: IdeLogLevel -> String # showList :: [IdeLogLevel] -> ShowS #
Eq IdeLogLevel # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeLogLevel -> IdeLogLevel -> Bool # (/=) :: IdeLogLevel -> IdeLogLevel -> Bool #

data IdeConfiguration #

Constructors

IdeConfiguration |

Fields

- confOutputPath :: FilePath
- confLogLevel :: IdeLogLevel
- confGlobs :: [FilePath]
- confGlobsFromFile :: Maybe FilePath
- confGlobsExclude :: [FilePath]

data IdeEnvironment #

Constructors

IdeEnvironment |

Fields

- ideStateVar :: TVar IdeState
- ideConfiguration :: IdeConfiguration
- ideCacheDbTimestamp :: IORef (Maybe UTCTime)

type Ide (m :: Type -> Type) = (MonadIO m, MonadReader IdeEnvironment m) #

data IdeState #

Constructors

IdeState |

Fields

- ideFileState :: IdeFileState
- ideVolatileState :: IdeVolatileState

#### Instances

Instances details

Show IdeState # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeState -> ShowS # show :: IdeState -> String # showList :: [IdeState] -> ShowS #

emptyIdeState :: IdeState #

emptyFileState :: IdeFileState #

emptyVolatileState :: IdeVolatileState #

data IdeFileState #

`IdeFileState` holds data that corresponds 1-to-1 to an entity on the filesystem. Externs correspond to the ExternsFiles the compiler emits into the output folder, and modules are parsed ASTs from source files. This means, that we can update single modules or ExternsFiles inside this state whenever the corresponding entity changes on the file system.

Constructors

IdeFileState |

Fields

- fsExterns :: ModuleMap ExternsFile
- fsModules :: ModuleMap (Module, FilePath)

#### Instances

Instances details

Show IdeFileState # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeFileState -> ShowS # show :: IdeFileState -> String # showList :: [IdeFileState] -> ShowS #

data IdeVolatileState #

`IdeVolatileState` is derived from the `IdeFileState` and needs to be invalidated and refreshed carefully. It holds `AstData`, which is the data we extract from the parsed ASTs, as well as the IdeDeclarations, which contain lots of denormalized data, so they need to fully rebuilt whenever `IdeFileState` changes. The vsCachedRebuild field can hold a rebuild result with open imports which is used to provide completions for module private declarations

Constructors

IdeVolatileState |

Fields

- vsAstData :: AstData SourceSpan
- vsDeclarations :: ModuleMap [IdeDeclarationAnn]
- vsCachedRebuild :: Maybe (ModuleName, ExternsFile)

#### Instances

Instances details

Show IdeVolatileState # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeVolatileState -> ShowS # show :: IdeVolatileState -> String # showList :: [IdeVolatileState] -> ShowS #

newtype Match a #

Constructors

Match (ModuleName, a) |

#### Instances

Instances details

Functor Match # |
Instance details Defined in Language.PureScript.Ide.Types Methods fmap :: (a -> b) -> Match a -> Match b # (<$) :: a -> Match b -> Match a #
Show a => Show (Match a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> Match a -> ShowS # show :: Match a -> String # showList :: [Match a] -> ShowS #
Eq a => Eq (Match a) # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: Match a -> Match a -> Bool # (/=) :: Match a -> Match a -> Bool #

data Completion #

A completion as it gets sent to the editors

Constructors

Completion |

Fields

- complModule :: Text
- complIdentifier :: Text
- complType :: Text
- complExpandedType :: Text
- complLocation :: Maybe SourceSpan
- complDocumentation :: Maybe Text
- complExportedFrom :: [ModuleName]
- complDeclarationType :: Maybe DeclarationType

#### Instances

Instances details

ToJSON Completion # |
Instance details Defined in Language.PureScript.Ide.Types Methods toJSON :: Completion -> Value # toEncoding :: Completion -> Encoding # toJSONList :: [Completion] -> Value # toEncodingList :: [Completion] -> Encoding # omitField :: Completion -> Bool #
Show Completion # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> Completion -> ShowS # show :: Completion -> String # showList :: [Completion] -> ShowS #
Eq Completion # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: Completion -> Completion -> Bool # (/=) :: Completion -> Completion -> Bool #
Ord Completion # |
Instance details Defined in Language.PureScript.Ide.Types Methods compare :: Completion -> Completion -> Ordering # (<) :: Completion -> Completion -> Bool # (<=) :: Completion -> Completion -> Bool # (>) :: Completion -> Completion -> Bool # (>=) :: Completion -> Completion -> Bool # max :: Completion -> Completion -> Completion # min :: Completion -> Completion -> Completion #

identifierFromDeclarationRef :: DeclarationRef -> Text #

declarationType :: IdeDeclaration -> DeclarationType #

data Success #

Constructors

CompletionResult [Completion] |
TextResult Text |
UsagesResult [SourceSpan] |
MultilineTextResult [Text] |
ImportList (ModuleName, [(ModuleName, ImportDeclarationType, Maybe ModuleName)]) |
ModuleList [ModuleIdent] |
RebuildSuccess MultipleErrors |

#### Instances

Instances details

ToJSON Success # |
Instance details Defined in Language.PureScript.Ide.Types Methods toJSON :: Success -> Value # toEncoding :: Success -> Encoding # toJSONList :: [Success] -> Value # toEncodingList :: [Success] -> Encoding # omitField :: Success -> Bool #
Show Success # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> Success -> ShowS # show :: Success -> String # showList :: [Success] -> ShowS #

encodeSuccess :: ToJSON a => a -> Value #

encodeImport :: (ModuleName, ImportDeclarationType, Maybe ModuleName) -> Value #

data IdeNamespace #

Denotes the different namespaces a name in PureScript can reside in.

Constructors

IdeNSValue |
IdeNSType |
IdeNSModule |

#### Instances

Instances details

FromJSON IdeNamespace # |
Instance details Defined in Language.PureScript.Ide.Types Methods parseJSON :: Value -> Parser IdeNamespace # parseJSONList :: Value -> Parser [IdeNamespace] # omittedField :: Maybe IdeNamespace #
NFData IdeNamespace # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeNamespace -> () #
Generic IdeNamespace # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeNamespace |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeNamespace = D1 ('MetaData "IdeNamespace" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeNSValue" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "IdeNSType" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "IdeNSModule" 'PrefixI 'False) (U1 :: Type -> Type)))

Methods

from :: IdeNamespace -> Rep IdeNamespace x #

to :: Rep IdeNamespace x -> IdeNamespace #

Show IdeNamespace # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeNamespace -> ShowS # show :: IdeNamespace -> String # showList :: [IdeNamespace] -> ShowS #
Eq IdeNamespace # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeNamespace -> IdeNamespace -> Bool # (/=) :: IdeNamespace -> IdeNamespace -> Bool #
Ord IdeNamespace # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeNamespace -> IdeNamespace -> Ordering #

(<) :: IdeNamespace -> IdeNamespace -> Bool #

(<=) :: IdeNamespace -> IdeNamespace -> Bool #

(>) :: IdeNamespace -> IdeNamespace -> Bool #

(>=) :: IdeNamespace -> IdeNamespace -> Bool #

max :: IdeNamespace -> IdeNamespace -> IdeNamespace #

min :: IdeNamespace -> IdeNamespace -> IdeNamespace #

type Rep IdeNamespace # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeNamespace = D1 ('MetaData "IdeNamespace" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeNSValue" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "IdeNSType" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "IdeNSModule" 'PrefixI 'False) (U1 :: Type -> Type)))

data IdeNamespaced #

A name tagged with a namespace

Constructors

IdeNamespaced IdeNamespace Text |

#### Instances

Instances details

NFData IdeNamespaced # |
Instance details Defined in Language.PureScript.Ide.Types Methods rnf :: IdeNamespaced -> () #
Generic IdeNamespaced # |

Instance details

Defined in Language.PureScript.Ide.Types

Associated Types

type Rep IdeNamespaced |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeNamespaced = D1 ('MetaData "IdeNamespaced" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeNamespaced" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeNamespace) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: IdeNamespaced -> Rep IdeNamespaced x #

to :: Rep IdeNamespaced x -> IdeNamespaced #

Show IdeNamespaced # |
Instance details Defined in Language.PureScript.Ide.Types Methods showsPrec :: Int -> IdeNamespaced -> ShowS # show :: IdeNamespaced -> String # showList :: [IdeNamespaced] -> ShowS #
Eq IdeNamespaced # |
Instance details Defined in Language.PureScript.Ide.Types Methods (==) :: IdeNamespaced -> IdeNamespaced -> Bool # (/=) :: IdeNamespaced -> IdeNamespaced -> Bool #
Ord IdeNamespaced # |

Instance details

Defined in Language.PureScript.Ide.Types

Methods

compare :: IdeNamespaced -> IdeNamespaced -> Ordering #

(<) :: IdeNamespaced -> IdeNamespaced -> Bool #

(<=) :: IdeNamespaced -> IdeNamespaced -> Bool #

(>) :: IdeNamespaced -> IdeNamespaced -> Bool #

(>=) :: IdeNamespaced -> IdeNamespaced -> Bool #

max :: IdeNamespaced -> IdeNamespaced -> IdeNamespaced #

min :: IdeNamespaced -> IdeNamespaced -> IdeNamespaced #

type Rep IdeNamespaced # |

Instance details

Defined in Language.PureScript.Ide.Types

type Rep IdeNamespaced = D1 ('MetaData "IdeNamespaced" "Language.PureScript.Ide.Types" "purescript-0.15.15-8K0LbmS63k4ILju2RsIrDp" 'False) (C1 ('MetaCons "IdeNamespaced" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 IdeNamespace) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))